global _getCPUID

section .code

_getCPUID:

    push ebp 
    mov ebp,esp 
    sub esp,0x40

    ; Get the string
    mov eax, 00h
    cpuid
    mov eax, [ebp+8]
    mov [eax], ebx
    mov [eax+4], edx
    mov [eax+8], ecx

    ; Get the model and options
    mov eax, 01h
    cpuid
    mov ebx, [ebp+12]
    mov [ebx], eax
    mov ebx, [ebp+16]
    mov [ebx], edx

    ; Get the serial number ;-) hehehehe
    mov eax, 03h
    cpuid
    mov ebx, [ebp+40]
    mov [ebx], ecx
    mov [ebx+4], edx

    ; Get number of extended options (leave if none exist)
    mov eax, 80000000h
    cpuid
    and eax, 7fffffffh
    mov ecx, eax
    mov eax, [ebp+20]
    mov [eax], ecx
    jecxz getCPUIDexit

    ; Get the 3DNow capabilities
    mov eax, 80000001h
    cpuid
    mov eax, [ebp+24]
    mov [eax], edx

    ; Get the long processor string (null terminated if < 48 chars)
    mov eax, 80000002h
    cpuid
    push edx
    mov edx, [ebp+28]
    mov [edx], eax
    mov [edx+4], ebx
    mov [edx+8], ecx
    mov eax, edx
    pop edx
    mov [eax+12], edx
    mov eax, 80000003h
    cpuid
    push edx
    mov edx, [ebp+28]
    mov [edx+16], eax
    mov [edx+20], ebx
    mov [edx+24], ecx
    mov eax, edx
    pop edx
    mov [eax+28], edx
    mov eax, 80000004h
    cpuid
    push edx
    mov edx, [ebp+28]
    mov [edx+32], eax
    mov [edx+36], ebx
    mov [edx+40], ecx
    mov eax, edx
    pop edx
    mov [eax+44], edx

    ; Get the L1 cache information
    mov eax, 80000005h
    cpuid
    mov eax, [ebp+32]
    mov [eax], ebx
    mov [eax+4], ecx
    mov [eax+8], edx

    ; Get the L2 cache information
    mov eax, 80000006h
    cpuid
    mov eax, [ebp+36]
    mov [eax], ecx
    
getCPUIDexit:

    leave                  ; mov esp,ebp / pop ebp 
    ret

